# ===========================================================================
#
# single_wake.py
#
# Jensen wake Single Turbine
# CBP 02-12-21
#STATUS: rELEASE
#
# ===========================================================================
import matplotlib.pyplot as plt
import floris.tools as wfct

# Get the farm layout and turbine parameters
fi = wfct.floris_interface.FlorisInterface("./jsons/jensen.json")

# Calculate wake
fi.calculate_wake()

# calculate the total power
power = fi.get_farm_power()

print(" ----------------- ")
print("Total Power = %.2e   ( = %.1f )" % (power , power))
print(" ----------------- ")

cts = fi.get_turbine_ct();
print(" ----------------- ")
for i in range(len(cts)):
    print("Turbine %d Ct's = %.2e    ( = %.4f )" % (i,cts[i],cts[i]))

# Get horizontal plane at default height (hub-height)
hor_plane = fi.get_hor_plane()
     
# Plot and show
fig, ax = plt.subplots()
wfct.visualization.visualize_cut_plane(hor_plane, ax=ax)
plt.show()
